Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::ZipDataStream Class Reference

Specialisation of DataStream to handle streaming data from zip archives. More...

`#include <OgreZip.h>`

Inheritance diagram for Ogre::ZipDataStream:

[legend]
List of all members.

## Public Member Functions
| ZipDataStream (ZZIP_FILE *zzipFile, size_t uncompressedSize)
| Unnamed constructor.
| ZipDataStream (const String &name, ZZIP_FILE *zzipFile, size_t uncompressedSize)
| Constructor for creating named streams.
| ~ZipDataStream ()
size_t | read (void *buf, size_t count)
  | Parameters:
  | buf | Reference to a buffer pointer
  | count | Number of bytes to read
Returns: The number of bytes read
void | skip (long count)
| This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.
void | seek (size_t pos)
size_t | tell (void) const
bool | eof (void) const
void | close (void)
const String & | getName (void)
| Returns the name of the stream, if it has one.
template<typename T>
DataStream & | operator>> (T &val)
virtual size_t | readLine (char *buf, size_t maxCount, const String &delim="\n")
| Get a single line from the stream.
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace.
virtual String | getAsString (void)
| Returns a String containing the entire stream.
virtual size_t | skipLine (const String &delim="\n")
| Skip a single line from the stream.
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.
## Protected Attributes
ZZIP_FILE * | mZzipFile
String | mName
| The name (e.g. resource name) that can be used to identify the source fot his data (optional).
size_t | mSize
| Size of the data in the stream (may be 0 if size cannot be determined).

## Detailed Description

Specialisation of DataStream to handle streaming data from zip archives.

Definition at line 107 of file OgreZip.h.

## Constructor & Destructor Documentation

Ogre::ZipDataStream::ZipDataStream | ( | ZZIP_FILE * | zzipFile,
|  | size_t | uncompressedSize
| ) |

| Unnamed constructor.

Ogre::ZipDataStream::ZipDataStream | ( | const String & | name,
|  | ZZIP_FILE * | zzipFile,
|  | size_t | uncompressedSize
| ) |

| Constructor for creating named streams.

Ogre::ZipDataStream::~ZipDataStream | ( |  | ) |

## Member Function Documentation

void Ogre::ZipDataStream::close | ( | void |  | ) | `[virtual]`

| Implements Ogre::DataStream.

bool Ogre::ZipDataStream::eof | ( | void |  | ) | const`[virtual]`

| Implements Ogre::DataStream.

virtual String Ogre::DataStream::getAsString | ( | void |  | ) | `[virtual, inherited]`

| Returns a String containing the entire stream. Remarks: This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = `true` | ) | `[virtual, inherited]`

  | Returns a String containing the next line of data, optionally trimmed for whitespace. Remarks: This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required. Note: If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results. Parameters:
  | trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

const String& Ogre::DataStream::getName | ( | void |  | ) | `[inherited]`

| Returns the name of the stream, if it has one. Definition at line 72 of file OgreDataStream.h.

template<typename T>
DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) | `[inherited]`

size_t Ogre::ZipDataStream::read | ( | void * | buf,
|  | size_t | count
| ) | `[virtual]`

  | Parameters:
  | buf | Reference to a buffer pointer
  | count | Number of bytes to read
Returns: The number of bytes read Implements Ogre::DataStream.

virtual size_t Ogre::DataStream::readLine | ( | char * | buf,
|  | size_t | maxCount,
|  | const String & | delim = `"\n"`
| ) | `[virtual, inherited]`

  | Get a single line from the stream. Remarks: The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character. Note: If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results. Parameters:
  | buf | Reference to a buffer pointer
  | maxCount | The maximum length of data to be read, excluding the terminating character
  | delim | The delimiter to stop at
Returns: The number of bytes read, excluding the terminating character Reimplemented in Ogre::MemoryDataStream, and Ogre::FileStreamDataStream.

void Ogre::ZipDataStream::seek | ( | size_t | pos | ) | `[virtual]`

| Implements Ogre::DataStream.

size_t Ogre::DataStream::size | ( | void |  | ) | const`[inherited]`

| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. Definition at line 149 of file OgreDataStream.h.

void Ogre::ZipDataStream::skip | ( | long | count | ) | `[virtual]`

| This can also be a negative value, in which case the file pointer rewinds a defined number of bytes. Implements Ogre::DataStream.

virtual size_t Ogre::DataStream::skipLine | ( | const String & | delim = `"\n"` | ) | `[virtual, inherited]`

  | Skip a single line from the stream. Note: If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results. Parameters:
  | delim | The delimiter(s) to stop at
Returns: The number of bytes skipped Reimplemented in Ogre::MemoryDataStream.

size_t Ogre::ZipDataStream::tell | ( | void |  | ) | const`[virtual]`

| Implements Ogre::DataStream.

## Member Data Documentation

String Ogre::DataStream::mName`[protected, inherited]`

| The name (e.g. resource name) that can be used to identify the source fot his data (optional). Definition at line 62 of file OgreDataStream.h.

size_t Ogre::DataStream::mSize`[protected, inherited]`

| Size of the data in the stream (may be 0 if size cannot be determined). Definition at line 64 of file OgreDataStream.h.

ZZIP_FILE* Ogre::ZipDataStream::mZzipFile`[protected]`

| Definition at line 110 of file OgreZip.h.

The documentation for this class was generated from the following file:

- OgreZip.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:49 2008